// Web3DView.cpp : implementation of the CWeb3DView class
//

#include "stdafx.h"
#include "Web3D.h"

#include "Web3DDoc.h"
#include "Web3DView.h"

#include "src/w3Dcore.h"


w3DIntegration		w3D;

// Modeling List
w3DGroup			scene;

w3DCamera			cam(0, 500, 7000, -20, 0, 0);
w3DTranslate		trans(0, 0, 0);
w3DGroup			attr;
w3DModelRenderer	mod;



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWeb3DView

IMPLEMENT_DYNCREATE(CWeb3DView, CView)

BEGIN_MESSAGE_MAP(CWeb3DView, CView)
	//{{AFX_MSG_MAP(CWeb3DView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWeb3DView construction/destruction

CWeb3DView::CWeb3DView()
{
	// TODO: add construction code here

}

CWeb3DView::~CWeb3DView()
{
}

BOOL CWeb3DView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWeb3DView drawing

void CWeb3DView::OnDraw(CDC* pDC)
{
	CWeb3DDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	w3D.sys.Process();
	w3D.sys.Swap();
}

/////////////////////////////////////////////////////////////////////////////
// CWeb3DView printing

BOOL CWeb3DView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CWeb3DView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CWeb3DView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CWeb3DView diagnostics

#ifdef _DEBUG
void CWeb3DView::AssertValid() const
{
	CView::AssertValid();
}

void CWeb3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CWeb3DDoc* CWeb3DView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWeb3DDoc)));
	return (CWeb3DDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWeb3DView message handlers

int CWeb3DView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	w3D.sys.AdjustCSInfo(*lpCreateStruct);
	
	return 0;
}

void CWeb3DView::OnDestroy() 
{
	CView::OnDestroy();
	
	w3D.sys.Stop();
}

BOOL CWeb3DView::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CWeb3DView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	w3D.sys.Resize(cx, cy);
	Invalidate();
}

void CWeb3DView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// init SGL
	w3D.Init(m_hWnd);

	// set active camera
	w3D.sys.SetActiveCamera(&cam);

	mod.Init("out.bin");

	attr.Add(&trans);
	mod.SetAttrib(&attr);
	scene.Add(&mod);

	// register the scene
	w3D.mod.SetModel(&scene);
	w3D.sys.Resume();
}
